function str_con=constb3a(x)
% str_con=constb3a(x)
% was str_con=constb3a(x,hh)
% Usage: Generating a preleminar constant for derive pop eval & parfit
%        optimization when x is the gene in hand.
% Written by: Yehu-David Horev
% Modified by: Maor Asher, Arthur Doroshev
%--------------------------------------------------------------------------
global data
str_con=[];
d_width=0.4911*log10(max(data(:,1))/min(data(:,1)))/length(data(:,1));
% checking Pseudo-Delta width
%if hh>=0.09
 %   d_width=hh;
%else
 %   d_width=0.09;
%end
% in each case the feachered peak is entered to the string with its
% parameters as '[1]', for the parametrization part between all peaks '+'
% operator is added
for i=1:length(x)
    % Pseudo Delta Function
    if x(i)=='D' 
        str_con=[str_con,'D([1],u1+[1],[',num2str(d_width),'])'];
    % R - Low Tau Delta Function
    elseif x(i)=='Y'
        str_con=[str_con,'Y([1],u1+[1],[',num2str(d_width),'])']; 
    % U - High Tau Delta Function
    elseif x(i)=='U' 
        str_con=[str_con,'U([1],u1+[1],[',num2str(d_width),'])'];
    % Gaussian
    elseif x(i)=='G' 
        str_con=[str_con,'G([1],u1+[1],[1])'];
    % Lorentzian
    elseif x(i)=='L'
        str_con=[str_con,'L([1],u1+[1],[1])']; 
    % Sech
    elseif x(i)=='S' 
        str_con=[str_con,'S([1],u1+[1],[1])']; 
    % Cole Cole
    elseif x(i)=='C' 
        str_con=[str_con,'C([1],u1+[1],[1])'];
    % Pearson VII
    elseif x(i)=='P' 
        str_con=[str_con,'P([1],u1+[1],[1],[1])'];
    % Losev
    elseif x(i)=='A' 
        str_con=[str_con,'A([1],u1+[1],[1],[1])'];
    % HN
    elseif x(i)=='H' 
        str_con=[str_con,'H([1],u1+[1],[1],[1])'];
    % KF
    elseif x(i)=='B' 
        str_con=[str_con,'B([1],u1+[1],[1])']; 
    % Asymmetric Gauss
    elseif x(i)=='F' 
        str_con=[str_con,'F([1],u1+[1],[1],[1])']; 
    % Asymmetric Lorenz
    elseif x(i)=='K'
        str_con=[str_con,'K([1],u1+[1],[1],[1])']; 
    % Asymmetric Sech
    elseif x(i)=='E'
        str_con=[str_con,'E([1],u1+[1],[1],[1])'];
    % Pseudo Voigt
    elseif x(i)=='V'
        str_con=[str_con,'V([1],u1+[1],[1],[1],[1])'];
    end
    % add terminal
    if i~=length(x)
        str_con=[str_con,'+']; 
    end
end