function e=modfmin(x,xm,u,y,yr)
% e = modfmin(x,xm,u,y,yr)
% Usage: This computes the optimal parameters in the model
% Written by: Yehu-David Horev
% Modified by: Arthur Doroshev
%--------------------------------------------------------------------------
global comm par
% Filter:
% load the filter parameters and sort them:
load([comm.dirname,'\','omega.GPDAT']);  
w0=omega(1);
w1=omega(2);

% Ramp:
% load the ramp:
load([comm.dirname,'\','rampa.GPDAT']);

% transpose u (log10(tau)) back into omega:
w=1./(10.^u);

% calculate filter vector:
filter=(1+exp(-5.*log10(w./w0)./log10(w1/w0))).^(-1);

% rename & change the string for calculation:
um=u; 
tau_diff=par.tau_diff;
hh=-(u(2)-u(1))/tau_diff;
t=(-20:hh:20);  
xm=strrep(xm,'u(:,1)','t');

% "eval" evaluates the string as if it was a regular code xm:
model=eval(xm);

% Model:
% Convolution
[mr,mi]=int_simpson_matrix(model,u,hh);

% Calculate the change in the iteration according to filter & ramp:
ea1=(y-mi).*filter;
ea1=ea1.*rampa;
ea2=(yr-mr).*filter;
ea2=ea2.*rampa;
%w1=0.9; 
ea=[ea1;ea2];
%eb=ea';
%em=[abs(mi);abs(mr)];
%[r,~]=size(ea);
% Output for fmincon:
%e=[];
%for i=1:r
%    e(i)=eb(1,i)*ea(i,1)/(em(i,1)+1e-04);
%end
%e=sum(e);
e=real(ea);
%-------------------------------------------
% output for fmincon 
e=e'*e;