function plot_model_main1(max_fit_pop,count_run,y,ym,yr,y_r,u,sse_plt,dis_plt,gen_ind,t,yrv,yv,sseall,treeall,bestsse,besttre,handles)
% plt_model=plot_model_main1(max_fit_pop,count_run,y,ym,yr,y_r,u,sse_plt,dis_plt,gen_ind,t,yrv,yv,sseall,treeall,bestsse,besttre,handles)
% Usage: visual view
%        max_fit_pop = the model string;
%        count_run = run number;
%        y = Im part; 
%        ym = genrated model Im part; 
%        yv = Im part of 2nd set;
%        yr = Re part; 
%        y_r = genrated model Re part; 
%        yrv = Re part of 2nd set;
%        sse_plt = competability from fitness;
%        gen_ind = generation number;
%        u1 = log10(tau); => was used in the past
%        sseall,treeall,bestsse,besttre => D.C plot parameters
% Created by: Alexander Tesler
% Modified by: Yehu-David Horev, Maor Asher, Arthur Doroshev
% this function is not used in the Graphic User Interface 
% by Alon Dana.
%--------------------------------------------------------------------------
global comm par data
% ploting the generatin data:
% -Z" vs. Z':
plot(handles.ax1,yr,-y,'.b',yrv,-yv,'.m',y_r,-ym,'k')
legend(handles.ax1,'Set1','Set2','Model','northwest','Location','NorthWest')
xlabel(handles.ax1,'Z','fontsize',10)
ylabel(handles.ax1,'-Z"','fontsize',10)

% Gamma func vs log10(tau):
hh=t(2)-t(1);
t_min=par.R.lb;
t_max=par.U.ub+2;
u1=t_min:hh:t_max;
plot(handles.ax2,u1,eval(max_fit_pop))
xlabel(handles.ax2,'log_1_0(\tau)','fontsize',10)
ylabel(handles.ax2,'\Gamma','fontsize',10)
t_min=-20;
t_max=u(1);
u1=t_min:hh:t_max;
Area=trapz(u1,eval(max_fit_pop));
u1=-20:hh:20;

% Discrepancy Complexity Plot:
semilogy(handles.ax3,treeall,sseall,'.g',besttre,bestsse,'diamondk',besttre(gen_ind+1),bestsse(gen_ind+1),'*r')
legend(handles.ax3,'All','Chosen','Generations Best')
xlabel(handles.ax3,'Complexity','fontsize',10)
ylabel(handles.ax3,'Discrepancy','fontsize',10)
set(handles.compatibility,'String',num2str(sse_plt));

% Residual vs log(w):
log10w=log10(2.*pi.*data(:,1));
residualIM=(y-ym)./(sqrt(y.^2+yr.^2));
residualRE=(yr-y_r)./(sqrt(y.^2+yr.^2));
plot(handles.ax4,log10w,residualIM,'b',log10w,residualRE,'r');
axis(handles.ax4,[log10w(1),log10w(end),-inf,inf])
legend(handles.ax4,'Set 1 - Im Part','Set 1 - Re Part')
xlabel(handles.ax4,'log_1_0(\omega)','fontsize',10)
ylabel(handles.ax4,'Residual','fontsize',10)

% convering max fit pop from "..u1+[0.2.." to "..u1-[-0.2..."
change=max_fit_pop;
a=strfind(change,'u');
for i=1:length(a)
    change(a(i)+2)='-';
    temp=change((a(i)+4):length(change));
    if(strcmp(change(a(i)+4),'-'))
       change(a(i)+4)='';
    else 
       change(a(i)+4)='-';
       change((a(i)+5):(a(i)+4+length(temp)))=temp;
    end
    a=strfind(change,'u');
end

% Calculation of the Areas under the peaks:
peak_mat=regexp(change,'+','split');
for ii=1:length(peak_mat)
    area_peak(ii)=trapz(hh,eval(peak_mat{ii}));
end
set(handles.bestmodel,'String',change);
set(handles.generation,'String',num2str(gen_ind));
set(handles.Area,'String',Area);

% result text file:
dlmwrite([comm.dirname,'\output\results_',num2str(count_run),'.txt'],['---------- Generation Number : ',num2str(gen_ind),' ----------'],'-append','delimiter','','newline','pc')
dlmwrite([comm.dirname,'\output\results_',num2str(count_run),'.txt'],'                          ','-append','delimiter','','newline','pc')
dlmwrite([comm.dirname,'\output\results_' num2str(count_run),'.txt'],['Best Model : ',num2str(change)],'-append','delimiter','','newline','pc')
dlmwrite([comm.dirname,'\output\results_',num2str(count_run),'.txt'],['Compatibility : ',num2str(sse_plt)],'-append','delimiter','','newline','pc')
dlmwrite([comm.dirname,'\output\results_',num2str(count_run),'.txt'],['Discrepancy : ',num2str(dis_plt)],'-append','delimiter','','newline','pc')
dlmwrite([comm.dirname,'\output\results_',num2str(count_run),'.txt'],['Total Area : ',num2str(Area)],'-append','delimiter','','newline','pc')
for i=1:length(area_peak)
dlmwrite([comm.dirname,'\output\results_',num2str(count_run),'.txt'],['Area Under Peak number ',num2str(i),' : ',num2str(area_peak(i))],'-append','delimiter','','newline','pc')
end
dlmwrite([comm.dirname,'\output\results_',num2str(count_run),'.txt'],'                          ','-append','delimiter','','newline','pc')

if par.generations==gen_ind

    % best model file:
    dlmwrite([comm.dirname,'\output\Best_Model_Data_',num2str(count_run),'.txt'],'ISGP Best Model Data : ','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Best_Model_Data_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Best_Model_Data_',num2str(count_run),'.txt'],['Run number : ' num2str(count_run) ],'-append','delimiter','','newline','pc')    
    dlmwrite([comm.dirname,'\output\Best_Model_Data_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Best_Model_Data_',num2str(count_run),'.txt'],'              Z''                      -Z"        ','-append','delimiter','','newline','pc')    
    for i=1:length(y_r)
        dlmwrite([comm.dirname,'\output\Best_Model_Data_' num2str(count_run),'.txt'],['               ',num2str(y_r(i)),'               ',num2str(-ym(i))],'-append','delimiter','','newline','pc')    
    end
    dlmwrite([comm.dirname,'\output\Best_Model_Data_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    
    % Gamma vs log10(tau) file:
    dlmwrite([comm.dirname,'\output\Gamma_v_log10(tau)_Data_',num2str(count_run),'.txt'],'ISGP Gamma vs Log10(tau) Data : ','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Gamma_v_log10(tau)_Data_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Gamma_v_log10(tau)_Data_',num2str(count_run),'.txt'],['Run number : ',num2str(count_run)],'-append','delimiter','','newline','pc')    
    dlmwrite([comm.dirname,'\output\Gamma_v_log10(tau)_Data_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Gamma_v_log10(tau)_Data_',num2str(count_run),'.txt'],'            Log10(tau)                  Gamma        ','-append','delimiter','','newline','pc')    
    mfp=eval(change);
    for i=1:length(u1)
        dlmwrite([comm.dirname,'\output\Gamma_v_log10(tau)_Data_',num2str(count_run),'.txt'],['               ',num2str(u1(i)),'               ',num2str(mfp(i)),],'-append','delimiter','','newline','pc')    
    end
    dlmwrite([comm.dirname,'\output\Gamma_v_log10(tau)_Data_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    
    % Discrepancy Complexity file:
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],'ISGP Discrepancy Complexity Data : ','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],['Run number : ' num2str(count_run) ] ,'-append','delimiter','','newline','pc')    
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],'The Chosen one : ','-append','delimiter','','newline','pc')   
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],['Complexity : ',num2str(besttre(gen_ind+1))],'-append','delimiter','','newline','pc')   
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],['Discrepancy : ',num2str(-log10(bestsse(gen_ind+1)))],'-append','delimiter','','newline','pc') 
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],'All : ','-append','delimiter','','newline','pc')   
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],'          Complexity              Discrepancy        ','-append','delimiter','','newline','pc')    
    for i=1:length(treeall)
        dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],['               ',num2str(treeall(i)),'               ',num2str(-log10(sseall(i)))],'-append','delimiter','','newline','pc')    
    end
    dlmwrite([comm.dirname,'\output\Discrepancy_Complexity_',num2str(count_run),'.txt'],'------------------------------------------------------------','-append','delimiter','','newline','pc')
    norm_factor=load([comm.dirname,'\','norm_factor.gpdat']);
    save([comm.dirname,'\',comm.name,'_run_',num2str(count_run)],'max_fit_pop','sse_plt','dis_plt','area_peak','norm_factor')
end
% drawnow causes figure windows and their children to update and flushes the system event queue. Any callbacks generated by incoming events. 
drawnow