function [pop_remove]=removepick(pop,mut_fun_set)
% [pop_remove]=removepick(pop,mut_fun_set)
% Usage: Removes a random peak from the gene.
%        pop = the string(gene) evolving
%        mut_fun_set = the bank of peaks can be used
% Written by: Yehu-David Horev
%--------------------------------------------------------------------------
% check weather a peak can be removed. (does the gene have more than one peak)
if length(pop)==1
    % if does not, choose one of the two other mechanisms randomly
    p=rand(1);
    if p<=0.5
        % Add
        pop_remove=addpick(pop,mut_fun_set);
    else
        % Swap
        pop_remove=swappick(pop,mut_fun_set);
    end
else
    % if does, choose who should be removed
    % "ceil" makes the calculation result as a whole number => 0.7=>1
    % "rand" chooses a number in random from 0 to 1
    remove=ceil(rand(1)*length(pop));
    % Remove
    pop_remove=[pop(1:remove-1),pop(remove+1:end)];
end