function welcome(varargin)
% welcome(varargin)
% ISGP version 3.1
% last modified: 17/11/2020 
% Changes Made since the last version:
% 1. Fix of the Lamda limit
% 2. I added the function that calculates the width of picks and the application of it in the script. Works!!
% 3. I added the functions for pick widthening, also to the script.
% 4. Show of Z(Re) in KKK.
% 5.  
% 6.
% This function is the first screen for ISGP. It explains about the program, shows the version, shows TOS.
% varargin = {comm}
% The comm structure is the communication factor between the screens.
% comm.pos = The last figure position. The current figure will take its place.
% comm.dirname = The name of the work directory.
% comm.name = the project's name.
% comm.movie = Whether the "save movie" check box was checked (project).
% comm.plot = Whether to plot axes on startup (LoadData).
% comm.UseFilter = Whether the filter was used the last time (LoadData).
% comm.LoadParamaters = Whether the user has changed any of the paramaters (Parameters).
% comm.path1 = The Path to DataSet1.
% comm.path2 = The Path to DataSet2.
% comm.spath1 = The short Path name to DataSet1.
% comm.spath2 = The short Path name to DataSet2.
% NOTE:
% comm.dirname is the WORKING dir name. 
% comm.path# is the DATA dir name.
% agreed: Check if the user had returned to this page from within the program,
% then set the default for the radio buttons to 'agreed'.
% Credits: Alex Tesler, Yehu David-Horev, Alon Dana, Maor Asher.
% Modified by: Arthur Doroshev
% new overlay
%--------------------------------------------------------------------------
global comm
Version='1.0';
if nargin==0
    % Set Default values:
    comm.pos=[240,227,800,550];
    comm.ramp(1:2,1:5)=-1;
    comm.dirname='0';
    comm.name='';
    comm.existingfile='';
    comm.movie=0;
    comm.plot=0;
    comm.UseFilter=0;
    comm.LoadParamaters=0;
    comm.path1='';
    comm.path2='';
    comm.path3='';
    comm.path4='';
    comm.spath1='';
    comm.spath2='';
    comm.spath3='';
    comm.spath4='';
    comm.check='';
    comm.kktcheckbox='';
    agreed=0;
else
    comm=varargin{1};
    agreed=1;
end

if comm.check==1
    comm.Abort=0;
end

screen1=figure('Position',comm.pos,'Color','White','MenuBar','none','NumberTitle','off','Name','Impedance Spectroscopy Genetic Programming','Resize','off','Tag','screen1');
if nargin==0
    movegui(screen1,'center')
end
    
handles=guihandles;
guidata(screen1,handles);
   
%------------ Buttons: ------------%
% Close:
handles.close=uicontrol('Style','pushbutton','Units','pixels','Position',[10,10,70,25],'FontSize',8,'FontWeight','bold','String','Close');
    
% Help:
handles.help=uicontrol('Style','pushbutton','Units','pixels','Position',[100,10,70,25],'FontSize',8,'FontWeight','bold','String','Help');
    
% Next:
handles.next=uicontrol('Style','pushbutton','Units','pixels','Position',[720,10,70,25],'FontSize',8,'Enable','off','FontWeight','bold','String','Next  >','Tag','Next');

if agreed==1
    set(handles.next,'Enable','on');
end
    
% Back:
uicontrol('Style','pushbutton','Units','pixels','Position',[630,10,70,25],'FontSize',8,'Enable','off','FontWeight','bold','String','<  Back');
    
% View TOS:
uicontrol('Style','pushbutton','Units','pixels','Position',[630,80,70,25],'FontSize',8,'CallBack',{@PBTOS,handles},'FontWeight','bold','String','View TOS');

%------------ Texts: ------------%
% Header:
axes('Parent',screen1,'Units','pixels','Position',[250,100,300,800],'CreateFcn',{@logo,handles});
    
% Version-Logo=ISGP:
uicontrol('Style','text','Units','pixels','Position',[10,430,200,20],'BackgroundColor','White','ForegroundColor','Black','FontName','Courier New','FontUnits','pixels','FontSize',15,'HorizontalAlignment','left','String','ISGP Version: 11/2020');
    
% Welcome, Copyright & Developers texts:
uicontrol('Style','text','Units','pixels','Position',[10,300,800,120],'BackgroundColor','White','ForegroundColor','Black','FontName','Courier New','FontUnits','pixels','FontSize',15,'HorizontalAlignment','left','String',...
          'Impedance Spectroscopy by Genetic Programming (ISGP) has been developed to solve ill-posed inverse problem of seeking a distribution function of relaxation times (DFT) from IS experimental results. The a-priori knowledge used is to assume the Debye kernel for dielectric systems, and to assume that the DFT is a combination of simple peaks. An evolutionary programming technique, GP, is used in order to identify "the best" DFT. Assessment of each model is done taking into account its complexity and the fitness of its prediction to the measured data.');
uicontrol('Style','text','Units','pixels','Position',[10,250,750,50],'BackgroundColor','White','ForegroundColor','Black','FontName','Courier New','FontUnits','pixels','FontSize',15,'HorizontalAlignment','left','String',...
          'Copyright 2009 by The Electroceramics and Nanotechnology Laboratory, in cooperation with The Process System Engineering Group, Department of Chemical Engineering, Technion - Israel Institute of Technology.');
uicontrol('Style','text','Units','pixels','Position',[10,220,800,20],'BackgroundColor','White','ForegroundColor','Black','FontName','Courier New','FontUnits','pixels','FontSize',15,'HorizontalAlignment','left','String',...
          'Visit us online at:  http://electroceramics.technion.ac.il/ ');
uicontrol('Style','text','Units','pixels','Position',[10,200,800,20],'BackgroundColor','White','ForegroundColor','Black','FontName','Courier New','FontUnits','pixels','FontSize',15,'HorizontalAlignment','left','String',...
          'By clicking "Next" button, you electronically agree to our Terms of Service (TOS).');
uicontrol('Style','text','Units','pixels','Position',[10,170,750,50],'BackgroundColor','White','FontSize',12,'FontWeight','bold','HorizontalAlignment','left','String',...
          'Developers: Alexander Tesler, Yehu David-Horev, Alon Dana, Maor Asher, Yoni Vaisberg, Rotem Yaniv, Arthur Doroshev');      
% Welcome, Copyright & Developers texts:
%axes('Parent',screen1,'Units','pixels','Position',[100,100,10,10],'CreateFcn',{@wcd,handles});    

% line:
%uipanel('Units','pixels','Position',[100,200,600,5],'BackgroundColor','white','BorderWidth',1,'Visible','on');
        
% link:
%axes('Units','pixels','Position',[0,0,0,0],'CreateFcn',{@link,handles});
h=uipanel('Units','pixels','Position',[200,225,350,2],'BorderType','none','BackgroundColor','black','ButtonDownFcn',{@WebLink,handles});
        
% Check if this Matlab version supports iptPointerManager
s=isstudent;
v=version;
if (s==0) && (str2double(v(1))>=7)
    iptPointerManager(gcf);
    enterFcn=@(hFigure,currentPoint)set(hFigure,'Pointer','hand');
    iptSetPointerBehavior(h,enterFcn);
end

% Check Box:
handles.check=uicontrol('Style','checkbox','Units','pixels','Position',[15,50,350,20],'BackgroundColor','White','FontSize',12,'Max',1,'Min',0,'CallBack',{@CheckBack,handles},'Value',0,'FontWeight','bold','String','I agree with the Terms of Service.');
if agreed==1
    set(handles.check,'Value',1);
    comm.Abort=0;
end
    
% Define Buttons' Callbacks:
set(handles.close,'CallBack',{@PBClose,handles});
set(handles.help,'CallBack',{@PBHelp,handles});
set(handles.next,'CallBack',{@PBNext,handles});
   
%------------ Functions: ------------%
% Create:
%function CreateFunction()
%clc

% Close Button:
function PBClose(hObject,eventdata,handles) 
button=questdlg('Are you sure you want to close the ISGP?','Close Confirmation Dialog','Yes','No','Yes');
if strcmp(button,'Yes')
    delete(handles.screen1)
end

% Help Button:
function PBHelp(hObject,eventdata,handles)  
web http://electroceramics.technion.ac.il/isgp/help.html

% Next Button:
function PBNext(hObject,eventdata,handles) 
global comm
comm.pos=get(handles.screen1,'Position');
project(comm)
delete(handles.screen1)

% View TOS Button:
function PBTOS(hObject,eventdata,handles)  
open('ISGP\TOS.pdf');

% Web Link:
function WebLink(hObject,eventdata,handles) 
web http://electroceramics.technion.ac.il/

% CheckBox CallBack:
function CheckBack(hObject,eventdata,handles) 
if (get(hObject,'Value')==get(hObject,'Max'))
    set(handles.next,'Enable','on');
else
    set(handles.next,'Enable','off');
end

% Load Logo:
function logo(hObject,eventdata,handles) 
img=imread('ISGP/lg.isgp');
image(img)
axis off
axis image

% Load Copyright:
function wcd(hObject,eventdata,handles) 
img=imread('ISGP/wcd.jpg');
image(img);
axis off
axis image

% Load link:
function link(hObject,eventdata,handles) 
img=imread('ISGP/link.isgp');
image(img);
axis off
axis image